Unit A_Design;

Interface

Uses  Crt,Dos;

Const
F1=1059;
F2=1060;
F3=1061;
F4=1062;
F5=1063;
F6=1064;
F7=1065;
F8=1066;
F9=1067;
F10=1068;

Shift_F1=1084;
Shift_F2=1085;
Shift_F3=1086;
Shift_F4=1087;
Shift_F5=1088;
Shift_F6=1089;
Shift_F7=1090;
Shift_F8=1091;
Shift_F9=1092;
Shift_F10=1093;

Ctrl_F1=1094;
Ctrl_F2=1095;
Ctrl_F3=1096;
Ctrl_F4=1097;
Ctrl_F5=1098;
Ctrl_F6=1099;
Ctrl_F7=1100;
Ctrl_F8=1101;
Ctrl_F9=1102;
Ctrl_F10=1103;

Alt_F1=1104;
Alt_F2=1105;
Alt_F3=1106;
Alt_F4=1107;
Alt_F5=1108;
Alt_F6=1109;
Alt_F7=1110;
Alt_F8=1111;
Alt_F9=1112;
Alt_F10=1113;

Home=1071;
Left=1075;
ToEnd=1079;
Up=1072;
Down=1080;
PgUp=1073;
Right=1077;
PgDn=1081;

Ctrl_Home=1119;
Ctrl_Left=1115;
Ctrl_ToEnd=1117;
Ctrl_PgUp=1132;
Ctrl_Right=1116;
Ctrl_PgDn=1118;

Ins=1082;
Del=1083;
Shift_Tab=1015;
Ctrl_Prtsc=1114;
Ctrl_Break=1000;

Enter=13;
Esc=27;
Space=32;
BackSpace=8;
Tab=9;

Alt_A=1030;
Alt_B=1048;
Alt_C=1046;
Alt_D=1032;
Alt_E=1018;
Alt_F=1033;
Alt_G=1034;
Alt_H=1035;
Alt_I=1023;
Alt_J=1036;
Alt_K=1037;
Alt_L=1038;
Alt_M=1050;

Alt_N=1049;
Alt_O=1024;
Alt_P=1025;
Alt_Q=1016;
Alt_R=1019;
Alt_S=1031;
Alt_T=1020;
Alt_U=1022;
Alt_V=1047;
Alt_W=1017;
Alt_X=1045;
Alt_Y=1021;
Alt_Z=1044;

Ctrl_A=01;
Ctrl_B=02;
Ctrl_C=03;
Ctrl_D=04;
Ctrl_E=05;
Ctrl_F=06;
Ctrl_G=07;
Ctrl_H=08;
Ctrl_I=09;
Ctrl_J=10;
Ctrl_K=11;
Ctrl_L=12;
Ctrl_M=13;

Ctrl_N=14;
Ctrl_O=15;
Ctrl_P=16;
Ctrl_Q=17;
Ctrl_R=18;
Ctrl_S=19;
Ctrl_T=20;
Ctrl_U=21;
Ctrl_V=22;
Ctrl_W=23;
Ctrl_X=24;
Ctrl_Y=25;
Ctrl_Z=26;

Alt_1=1120;
Alt_2=1121;
Alt_3=1122;
Alt_4=1123;
Alt_5=1124;
Alt_6=1125;
Alt_7=1126;
Alt_8=1127;
Alt_9=1128;
Alt_0=1129;
Alt_Minus=1130;
Alt_Equal=1131;

Var
      OkFileMask   : Boolean;
      Screen       : Array [1..4000] of Byte Absolute $B800:$0000;
      Scr          : Array [1..4000] of Byte;
      Key          : Integer;
      Ch           : Char;
      ChosePos     : Integer;
      TextOut      : String;
      ChoseName    : String;
      Param        : Byte;
      AskStr       : String;
      AsKCom       : String;
      AskLn        : Byte;
      CtrlBrk,
      DosErr,Click : Boolean;

Procedure AscStr(X,Y:Byte;Header,Keys:String;ColTxt,ColBack,Que:Byte);
Procedure Palette(Col,Value:Byte);
Procedure Message(S:String;Col:Byte);
Procedure Warning(S:String;ColTxt,ColBack:Byte;Que:Integer);
Procedure Shadow(X1,Y1,X2,Y2:Byte);
Procedure FillScreen(X1,Y1,X2,Y2,Symb,Col:Byte);
Procedure Colors(C,B:Byte);
Procedure Kursor(Y:Byte);
Procedure Member(IO:Byte);
Procedure GetKurPos(Var X,Y : Byte);
Procedure GetCurrentColor(Var C,B : Byte);
Procedure Clrs(B:Byte);
Procedure ExecNoCon(Prog,Param,ToOut : String);
Procedure Int24(Flags, CS, IP, AX, BX, CX, DX, SI, DI, DS, ES, BP: Word);Interrupt;
Procedure Reipl;
Procedure InBuff(S:String);
Function  Correct(Path:String):String;
Function  ScanKey:Integer;
Function  Convert(S:String):LongInt;
Function  CompStr(S,Mask:String):Boolean;
Function  UpStr(S:String):String;
Function  LowStr(S:String):String;
Function  ToDigit(S:String):Byte;

Implementation
Var ItsFirst : Integer;

Procedure Palette;
Var Reg : Registers;
Begin
   Reg.AH:=$10;
   Reg.AL:=0;
   Reg.BL:=Col;
   REG.BH:=Value;
   Intr($10,Reg);
End;

Procedure InBuff;
Var Reg : Registers;
    I   : Integer;
Begin
 I:=1;
 While I<=Length(S) Do
  Begin
   Reg.AH:=5;
   If S[I]='/' Then
    Begin
     Inc(I);
     Reg.CL:=0;
     Reg.CH:=Ord(S[I]);
    End
   Else
    Begin
     Reg.CH:=0;
     Reg.CL:=Ord(S[I]);
    End;
   Intr($16,Reg);
   Inc(I);
  End;
End;

Function  UpStr(S:String):String;
Var I : Integer;
Begin
 For I:=1 To Length(S) Do
  Begin
   If (S[I]>='a') And (S[I]<='z') Then S[I]:=Chr(Ord(S[I])-32);
   If (S[I]>='') And (S[I]<='') Then S[I]:=Chr(Ord(S[I])-32);
   If (S[I]>='') And (S[I]<='') Then S[I]:=Chr(Ord(S[I])-80);
  End;
 UpStr:=S;
End;

Function  LowStr(S:String):String;
Var I : Integer;
Begin
 For I:=1 To Length(S) Do
  Begin
   If (S[I]>='A') And (S[I]<='Z') Then S[I]:=Chr(Ord(S[I])+32);
   If (S[I]>='') And (S[I]<='') Then S[I]:=Chr(Ord(S[I])+32);
   If (S[I]>='') And (S[I]<='') Then S[I]:=Chr(Ord(S[I])+80);
  End;
 LowStr:=S;
End;

Function ToDigit;
Var B,I :Byte;
Begin
 B:=0;
 For I:=1 To 2 Do
  Begin
   If (S[I]>='0') And (S[I]<='9') Then B:=B Or (Ord(S[I])-48);
   If (S[I]>='A') And (S[I]<='F') Then B:=B Or (Ord(S[I])-55);
   If I=1 Then
    Asm
     MOV AL,B
     MOV CL,4
     ROL AL,CL
     MOV B,AL
    End;
  End;
 ToDigit:=B;
End;

{ ࠢ ப  蠡 < CompStr(~String~,~~) : Boolean >             }
{   ᪠ : ~*~ - 쪮 㣮  㣮,~?~ -   }
{ ~@~-쪮 㣮 ஡,~#~- ,~^~- (.⮦)}
Function  CompStr;
Var I,J     : Integer;
    Ok      : Boolean;
    St,Msk  : String;
Begin
 Inc(ItsFirst);
 I:=1;
 { ONETIME BLOCK                                                           }
 { Begin optimize mask ('?*','*?','**' secuences must be converted to '*') }
 {                     ('@@' secuences must be converted to '@')           }
 If ItsFirst=1 Then
  Begin
   If OkFileMask Then
    Begin
     Mask:=UpStr(Mask);
     S:=UpStr(S)
    End;
   While True Do
    Begin
     J:=Length(Mask);
     While I<Length(Mask) Do
      Begin
       If (Mask[I]='?') And (Mask[I+1]='*') Then
        Delete(Mask,I,1);
       If (Mask[I]='*') And (Mask[I+1]='?') And (I<Length(Mask)) Then
        Delete(Mask,I+1,1);
       If (Mask[I]='*') And (Mask[I+1]='*') And (I<Length(Mask)) Then
        Delete(Mask,I,1);
       If (Mask[I]='@') And (Mask[I+1]='@') And (I<Length(Mask)) Then
        Delete(Mask,I,1);
       Inc(I);
      End;
     If J=Length(Mask) Then Break;
     I:=1;
    End;
 { End of optimize mask convertion }
  End;
 Ok:=True;
 I:=1;
 J:=1;
 While TRUE Do
  Begin
   Case Mask[I] Of
    { Begin compareing string with current mask sign }
     { Star sign     : any match any simbols }
    '*':
      Begin
       Msk:=Copy(Mask,I+1,Length(Mask)-I+1);
       St:=Copy(S,J,Length(S)-J+1);
       While (St<>'') And (NOT CompStr(St,Msk)) Do Delete(St,1,1);
       If (St='') And (Msk<>'') Then Ok:=False Else J:=Pos(St,S);
      End;
     { Question sign : one match any simbol  }
    '?':
     Begin
      If (I=Length(Mask)) And (J<Length(S)) Then Ok:=False;
      If J>Length(S) Then Ok:=False;
      Inc(J);
     End;
     { Dies sign : one match any digit }
    '#':
     Begin
      If Not OkFileMask Then
       Begin
        If (I=Length(Mask)) And (J<Length(S)) Then Ok:=False;
        If J>Length(S) Then Ok:=False;
        If (S[J]>='0') Or (S[J]<='9') Then Inc(J) Else Ok:=False;
       End;
     End;
     { Up sign : one match upcase simbol }
    '^':
     Begin
      If Not OkFileMask Then
       Begin
        If (I=Length(Mask)) And (J<Length(S)) Then Ok:=False;
        If J>Length(S) Then Ok:=False;
        If ((S[J]>='A') Or (S[J]<='Z')) Or ((S[J]>='') Or (S[J]<=''))
         Then Inc(J) Else Ok:=False;
       End;
     End;
    '@':
     Begin
      If Not OkFileMask Then
       Begin
        If (I=Length(Mask)) And (J<Length(S)) Then Ok:=False;
        If J>Length(S) Then Ok:=False;
        If S[J]<>' ' Then Ok:=False;
        While S[J]=' ' Do Inc(J);
       End;
     End;
     { Compare simbols }
    Else If Mask[I]<>S[J] Then Ok:=False Else Inc(J);
    { End compareing string with current mask sign }
    End;
   { Result of compareing }
   If J-1>Length(S) Then Ok:=False;
   If Not Ok Then Break;
   Inc(I);
   If I>Length(Mask) Then Break;
  End;
 CompStr:=Ok;
 Dec(ItsFirst);
End;

{ १㧪 }
Procedure Reipl;
Begin
 Inline($EA/$00/$00/$FF/$FF);
End;

{ 맮 ணࠬ  ७ࠢ 뢮  䠩 }
Procedure ExecNoCon;
Var NDir    : Array[1..80] of Byte;
    SSt     : String;
    I       : Integer;
    F       : Text;
    Reg     : Registers;
    Desc,
    OldDisc : Word;
Begin
 Sst:=ToOut;
 Sst:=Sst+#0;
 For I:=1 To Length(Sst) Do
  Ndir[I]:=Ord(Sst[I]);
 Assign(F,ToOut);
 Rewrite(F);
 Close(F);
 {Open File}
 Reg.AH:=$3D;
 Reg.AL:=2;
 Reg.DS:=Seg(Ndir);
 Reg.DX:=Ofs(Ndir);
 MsDos(Reg);
 Desc:=Reg.AX;
 {Duplicate Discriptor}
 Reg.AH:=$45;
 Reg.BX:=1;
 MsDos(Reg);
 Olddisc:=Reg.AX;
 {ReDirect Discriptor}
 Reg.AH:=$46;
 Reg.BX:=Desc;
 Reg.CX:=1;
 MsDos(Reg);
 {Close File}
 Reg.AH:=$3E;
 Reg.BX:=Desc;
 MsDos(Reg);
 {Execute File}
 SwapVectors;
 Exec(Prog,Param);
 SwapVectors;
 {Stay Old Descriptor}
 Reg.AH:=$46;
 Reg.BX:=Olddisc;
 Reg.CX:=1;
 MsDos(Reg);
 {Close Olddisc}
 Reg.AH:=$3E;
 Reg.BX:=Olddisc;
 MsDos(Reg);
End;

{ ࠡ⪠ ᪮ 訡 }
Procedure Int24;
Var C,B,X,Y : Byte;
    Reg     : Registers;
Begin
 C:=TextAttr And $0F;
 B:=TextAttr And $F0;
 Reg.AH:=3;
 Reg.BH:=0;
 Intr($10,Reg);
 X:=Reg.DL+1;
 Y:=Reg.DH+1;
  Case DI Of
    0: Warning('@15FROM ACAR : ERROR !!!#DISK IS WRITE PROTECTED#'+
               '~RETRY    ~ABORT',14,$4E,0);
    1: Warning('@15FROM ACAR : ERROR !!!#DRIVE NOT READY#'+
               '~RETRY    ~ABORT',14,$4E,0);
    2: Warning('@15FROM ACAR : ERROR !!!#DRIVE NOT READY#'+
               '~RETRY    ~ABORT',14,$4E,0);
    3: Warning('@15FROM ACAR : ERROR !!!#UNCKNOWN DISK COMMAND#'+
               '~RETRY    ~ABORT',14,$4E,0);
    8: Warning('@15FROM ACAR : ERROR !!!#SECTOR NOT FOUND#'+
               '~RETRY    ~ABORT',14,$4E,0);
   10: Warning('@15FROM ACAR : ERROR !!!#DISK WRITE ERROR#'+
               '~RETRY    ~ABORT',14,$4E,0);
   11: Warning('@15FROM ACAR : ERROR !!!#DISK READ ERROR#'+
               '~RETRY    ~ABORT',14,$4E,0);
  Else Warning('@15FROM ACAR : ERROR !!!#URECOGNISED DISK ERROR#'+
               '~RETRY    ~ABORT',14,$4E,0);
 End;
 If (Key=Esc) Or (ChosePos=1) Then AX:=3 Else AX:=1;
 Colors(C,B);
 GotoXY(X,Y);
End;

Procedure GetKurPos;
Var Reg : Registers;
Begin
 Reg.AH:=3;
 Reg.BH:=0;
 Intr($10,Reg);
 X:=Reg.DL+1;
 Y:=Reg.DH+1;
End;

{ ⥪騩 梥}
Procedure GetCurrentColor;
Var Reg : Registers;
Begin
 C:=TextAttr And $0F;
 B:=TextAttr And $F0;
End;

{४஢ }
Function Correct(Path:String):String;
Begin
 If Length(Path)<3 Then Correct:=Path+'\' Else Correct:=Path;
End;

{ ᪠    ப ( MESSAGE [ String : ⥪ ][ COL : 梥 ]) }
Procedure Message;
Var   I : Integer;
Begin
      I:=3842;
      While I<4002 Do
       Begin
        Screen[I]:=Col;
        Screen[I-1]:=$20;
        I:=I+2;
       End;
       For I:=1 To Length(S) Do
        Begin
         Screen[I*2+3841]:=Ord(S[I]);
        End;
End;

Procedure Member;
Begin
  If IO=0
  Then Move(Screen,Scr,SizeOf(Scr))
  Else Move(Scr,Screen,SizeOf(Scr));
End;

Function Convert;
Var I   : Integer;
    P   : String;
    Res : LongInt;
    D   : LongInt;
Begin
  Res:=0;
  D:=1;
  P:='';
  For I:=1 To Length(S) Do If (S[I]>='0') And (S[I]<='9') Then P:=P+S[I];
  S:=P;
  For I:=Length(S) DownTo 1 Do
   Begin
    Res:=Res+(Ord(S[I])-48)*D;
    D:=D*10;
   End;
   Convert:=Res;
End;

{ 祭/襭  KURSOR( [ 0-몫 ] / [ 1- ] ) }
Procedure Kursor;
Begin
If Y=0 Then
 Begin
  ASM
   push cx
   push ax
   mov ah,01h
   mov ch,20h
   mov cl,0
   int 10h
   pop ax
   pop cx
  End;
 End
Else
 Begin
  ASM
   push cx
   push ax
   mov ah,01h
   mov ch,7
   mov cl,8
   int 10h
   pop ax
   pop cx
  End;
 End;
End;

{ ࠭ FILLSCREEN( x1,y1,x2,y2,[ C ],[ 梥 ] )}
Procedure FillScreen;
Var I,J : Integer;
Begin
      For J:=Y1 to Y2 do
       Begin
        For I:=X1 to X2 do
         Begin
          Screen[(J*80-80+I)*2+2]:=Col;
          Screen[(J*80-80+I)*2+1]:=Symb;
         End;
       End;
End;

{  }
Procedure Shadow;
Var   I,V : Byte;
Begin
      If X2<80 Then V:=X2+1 Else V:=X2;
      For I:=X1+1 to V do
       Begin
        Screen[((Y2+1)*80-80+I)*2]:=$8;
       End;
      If X2<80 Then
       Begin
        For I:=Y1 to Y2+1 do
         Begin
          Screen[(I*80-79+X2)*2]:=$8;
         End;
       End;
End;

Procedure Clrs(B:Byte);
Begin
 TextColor(B And $0F);
 Asm
  mov ch,b
  ror cx,1
  ror cx,1
  ror cx,1
  ror cx,1
  mov b,ch
 End;
 TextBackGround(B);
End;

Procedure AscStr;
Label 1;
Var N,J,I,K : Integer;
    Sr,Str  : String;
    Zoom    : Boolean;
    Pos     : Byte;
    C       : Array[1..10] of String[5];
Begin
 Kursor(1);
 If Length(Header)+2>AskLn+Length(AskCom) Then
  J:=Length(Header)+6
 Else If Length(AskCom)<>0 Then J:=AskLn+6+Length(AskCom)
      Else J:=AskLn+5;
 Clrs(ColBack);
 GotoXY(X,Y);
 Write('');
 Header:=' '+Header+' ';
 Sr:='';
 For I:=1 To (J-Length(Header)-2) Div 2 Do Sr:=Sr+'';
 Str:=Sr;
 If (J-Length(Header)-2) Mod 2=1 Then Str:=Str+'';
 Str:=Str+'';
 Write(Sr);
 Write(Header);
 Write(Str);
 Sr:='';
 Str:='';
 For I:=1 To J-2 Do
  Begin
   Str:=Str+'';
   Sr:=Sr+' ';
  End;
 Sr:=Sr+'';
 Str:=Str+'';
 GotoXY(X,Y+1);
 Write(Sr);
 GotoXY(X,Y+2);
 Write(Str);
 Clrs(ColTxt);
 GotoXY(X+2,Y+1);
 If Que<>2 Then Write(AskStr)
  Else
   For I:=1 To Length(AskStr) Do Write('*');
 Sr:='';
 Clrs(ColTxt);
 For I:=1 To AskLn-Length(AskStr)+1 Do Sr:=Sr+' ';
 Write(Sr);
 GotoXY(X+4+AskLn,Y+1);
 Write(AskCom);
 If Que<3 Then Shadow(X,Y+1,X+J-1,Y+2);
 If (Que<>1) And (Que<>3) Then
  Begin
   Pos:=1;
   GotoXY(X+2,Y+1);
   Key:=Home;
   K:=1;
   For I:=0 To 10 Do C[I]:='';
   For I:=1 To Length(Keys) Do
    Begin
     If Keys[I]=' ' Then
      Begin
       K:=K+1;
      End;
     C[K]:=C[K]+Keys[I];
    End;
   For I:=1 To K Do
    Begin
     If Key=Convert(C[I]) Then Goto 1;
    End;
   If ((Key<Ord(' ')) Or (Key>Ord(''))) Then Askstr:=AskStr
   Else
    Begin
     Pos:=2;
     AskStr:=Chr(Key);
    End;
   Window(X+2,Y+1,X+2+AskLn,Y+1);
   Clrs(ColTxt);
   ClrScr;
   GotoXY(1,1);
   If Que<>2 Then Write(AskStr)
    Else
     For I:=1 To Length(AskStr) Do Write('*');
   Zoom:=True;
   While Zoom=True Do
    Begin
     If Key=ToEnd Then Pos:=Length(AskStr)+1;
     If Key=Home Then Pos:=1;
     If Key=Del Then
      Begin
       ClrScr;
       Delete(AskStr,Pos,1);
       If Que<>2 Then Write(AskStr)
        Else
         For I:=1 To Length(AskStr) Do Write('*');
      End;
     If (Key=BackSpace) And (Pos>1) Then
      Begin
       Pos:=Pos-1;
       ClrScr;
       Delete(AskStr,Pos-1,2);
       If Pos>1 Then Pos:=Pos-1;
       If Que<>2 Then Write(AskStr)
        Else
         For I:=1 To Length(AskStr) Do Write('*');
      End;
     If (Key=Left) And (Pos>1) Then Pos:=Pos-1;
     If (Key=Right) And (Pos<Length(AskStr)+1) Then Pos:=Pos+1;
     If Pos>AskLn Then Pos:=AskLn;
     If Ch<>Chr(0) Then
      Begin
       GotoXY(1,1);
       If Que<>2 Then Write(AskStr)
        Else
         For I:=1 To Length(AskStr) Do Write('*');
      End;
     GotoXY(Pos,1);
     Key:=ScanKey;
     For I:=1 To K do
     If Key=Convert(C[I]) Then
      Begin
       Zoom:=False;
       Goto 1;
      End;
     If Ch<>Chr(0) Then
      Begin
       If Pos<=Length(AskStr) Then
        Begin
         If (Length(AskStr)<AskLn) Then
          Begin
           Sr:=Ch;
           Insert(Sr,AskStr,Pos);
          End
         Else Pos:=Pos-1;
        End
       Else AskStr:=AskStr+Ch;
       Pos:=Pos+1;
      End;
     If Key=Esc Then
      Begin
       Zoom:=False;
      End;
     If Length(AskStr)>AskLn Then AskStr:=Copy(AskStr,1,11);
    End;
1: Window(1,1,80,25);
   Kursor(0);
  End;
End;

Procedure Warning;
Var St     : Array [0..10] of String;
    N,J    : Byte;
    Stw,
    Sr,Str : String;
    Scr    : Array [1..4000] of Byte;
    C,MB,
    LMB    : Array [1..10] of Byte;
    Kl,I,
    K,Xx,M : Integer;
    MayBe  : Array[1..4] Of String[20];
    Bl     : Boolean;
    Cl,Bk  : Byte;
    Xp,Yp  : Byte;
    Xw1,
    Yw1,
    Xw2,
    Yw2    : Byte;

Begin
 GetCurrentColor(Cl,Bk);
 GetKurPos(Xp,Yp);
 Xw1:=Lo(WindMin);
 Yw1:=Hi(WindMin);
 Xw2:=Lo(WindMax);
 Yw2:=Hi(WindMax);
 Window(1,1,80,25);
 I:=0;
 While I<=9 do
  Begin
   St[I]:='';
   C[I+1]:=ColTxt;
   Inc(I)
  End;
 Move(Screen,Scr,SizeOf(Screen));
 N:=1;
 I:=0;
 Kl:=1;
 While I<Length(S) Do
  Begin
   Inc(I);
   If S[I]='@' Then
    Begin
     Inc(I);
     Str:='';
     While (S[I]>'0') And (S[I]<'9') Do
      Begin
       Str:=Str+S[I];
       Inc(I);
      End;
     C[N]:=Convert(Str);
    End;
   If S[I]='#' Then
    Begin
     Inc(N);
    End;
   If S[I]='~' Then
    Begin
     If Kl<2 Then
      Begin
       Inc(N);
      End;
     Stw:=Copy(S,I+1,Length(S)-I+2)+' ';
     Xx:=Pos(' ',Stw);
     If Xx=0 Then Xx:=Pos('~',Stw);
     If (Xx>Pos('~',Stw)) And (Pos('~',Stw)>0) Then Xx:=Pos('~',Stw);
     MayBe[Kl]:=Copy(S,I+1,Xx-1);
     Inc(Kl);
    End;
   If (S[I]<>'#') And (S[I]<>'@') And (S[I]<>'~') Then St[N]:=St[N]+S[I];
   If S[I]='~' Then St[N]:=St[N]+' ';
  End;
 Dec(Kl);
 J:=Length(St[1]);
 Str:='';
 Sr:='';
 For I:=1 To N Do If Length(St[I])>J Then J:=Length(St[I]);
 For I:=1 To J+4 Do Str:=Str+'';
 For I:=1 To J+4 Do Sr:=Sr+'';
 St[0]:=''+Str+'';
 St[N+1]:=''+Sr+'';
 Clrs(ColBack);
 GotoXY((81-J) Div 2-3,10);
 Write(St[0]);
 For I:=1 To N Do
  Begin
   Str:='';
   Sr:='';
   For K:=1 To (J+4-Length(St[I])) Div 2 Do Sr:=Sr+' ';
   For K:=1 To (J+4-Length(St[I])) Div 2+(J+4-Length(St[I])) Mod 2 Do
     Str:=Str+' ';
   St[I]:=Str+St[I]+Sr;
   GotoXY((81-J) Div 2-3,I+10);
   Clrs(ColBack);
   Write('');
   TextColor(C[I]);
   Write(St[I]);
   Clrs(ColBack);
   Write('');
  End;
 GotoXY((81-J) Div 2-3,N+11);
 Clrs(ColBack);
 Write(St[N+1]);
 Shadow((81-J) Div 2-3,11,(81-J) Div 2+2+J,N+11);
 I:=0;
 If Que>0 Then
  Begin
   While (NOT KeyPressed) And (Que>0) Do
    Begin
     Que:=Que-1;
     Delay(30);
    End;
   Que:=0;
  End
 Else
  If Que=0 Then
   Begin
    If Kl<1 Then Key:=ScanKey
    Else
     Begin
      Key:=0;
      Bl:=False;
      Str:=St[N];
      I:=1;
      K:=1;
      While I<>Length(Str) Do
       Begin
        If Str[I]<>' ' Then
         Begin
          MB[K]:=I;
          Stw:=Copy(Str,I,Length(Str)-I);
          LMB[K]:=Pos(' ',Stw)-1;
          I:=I+(Pos(' ',Stw)-1);
          Inc(K);
         End;
        Inc(I);
       End;
      Dec(K);
      I:=1;
      GotoXY((81-(Length(St[N])+6)) Div 2+MB[I],N+10);
      Clrs(ColBack);
      Write('[ '+MayBe[I]+' ]');
      While (Key<>Esc) And (Key<>Enter) And (NOT Bl) Do
       Begin
        Key:=ScanKey;
        GotoXY((81-(Length(St[N])+6)) Div 2+MB[I],N+10);
        TextColor(ColTxt);
        Write('  '+MayBe[I]+'  ');
        If (Key=Left) And (I>1) Then Dec(I);
        If (Key=Right) And (I<Kl) Then Inc(I);
        For M:=1 To Kl Do If UpCase(Ch)=Copy(MayBe[M],1,1) Then Bl:=True;
        GotoXY((81-(Length(St[N])+6)) Div 2+MB[I],N+10);
        Clrs(ColBack);
        Write('[ '+MayBe[I]+' ]');
       End;
      AskStr:=MayBe[I];
      ChosePos:=I;
     End;
   End;
 While KeyPressed Do Key:=ScanKey;
 If Que=0 Then
  Begin
   Move(Scr,Screen,SizeOf(Screen));
  End;
 Colors(Cl,Bk);
 GotoXY(Xp,Yp);
 Window(Xw1,Yw1,Xw2,Yw2);
End;

Procedure Colors;
Begin
      TextColor(C);
      TextBackGround(B);
End;

Function ScanKey;
Begin
   Ch:=Chr(0);
   Key:=0;
   Ch:=ReadKey;
   ScanKey:=Ord(Ch);
   if Ch=Chr(0) Then ScanKey:=Ord(Readkey)+1000;
End;

Begin
 ItsFirst:=0;
 SetIntVec($24,Addr(Int24));
End.